unit LockDemo;
{ *****************************************************

                         LockDemo

  *****************************************************

    Copyright 1997 by Martin Djerns (rel.130397)

  ***************************************************** }

interface

Uses
  Classes,    { RegisterClass, RegisterComponents    }
  mdSWLock,   { The SWLock module - see mdSWLock.txt }
  LockEdit;   { Another Lock editor                  }

Type
{ --- TLockDemo / TmdLockDemo.About : TLockDemo --- }

  TLockDemo = Class(TmdSWLock)
  Protected
    Function RegIdent : TmdRegString; Override;
  Public
    Function GetStr(Code : Integer) : String; Override;
  end;

{ --- TmdLockDemo / Component which should be registered --- }

  TmdLockDemo = Class(TComponent)
    FAbout : TLockDemo;
  Public
    Constructor Create(AOwner : TComponent); Override;
    Destructor Destroy; Override;
  Published
    Property About : TLockDemo Read FAbout Write FAbout;
  end;

Procedure Register;

implementation


{ --- TLockDemo --- }

Function TLockDemo.RegIdent : TmdRegString;
Begin
  { This string is used to make your own unique version of the mdSWLock }
  { - The prefix (befor the comma) is a visible ID which will be the
      first part of the registration key
    - The suffix (after the comma) is included in the registration key
      so you key not looks like any others }
  Result := 'DEMO,Demo code';
end;

Function TLockDemo.GetStr(Code : Integer) : String;
Begin
  { Custom error/information strings
    - only sNotRegisteret and sCopyright exists }
  Case Code of
    sNotRegistered :
      Result := 'The component '+Owner.ClassName+' is not registret - '+
                'Demo component by Martin Djerns 1997';
    sCopyright : Result := Owner.ClassName+
                ' by Martin Djerns 1997';
  else
    Result := Inherited GetStr(Code);
  end;
end;

{ --- TmdLockDemo --- }

Constructor TmdLockDemo.Create(AOwner : TComponent);
Begin
  Inherited Create(AOwner);
  FAbout := TLockDemo.Create(Self); { Locks the component passed as Owner }
end;

Destructor TmdLockDemo.Destroy;
Begin
  FAbout.Free;                      { Release you memory :-) }
  Inherited Destroy;
end;

Procedure Register;
Begin
  { Register the Demo component   }
  RegisterComponents('mdVCL', [TmdLockDemo]);
  RegisterSWLock(TypeInfo(TLockDemo),   { Register the property for the }
                 TmdLockDemo,           { Delphi enviroment             }
                 'About',
                 TfmLockEdit); { <-- Alternative editor }
end;

Initialization
  RegisterClass(TmdLockDemo);       { All classes which should be detected
                                      by the mdSWLock should be
                                      registered in runtime }
end.
